///////////////////////////////////////////////////////////////////////////////
//
// This software module was originally developed by
//
// Intel Corporation
// (contributing organizations names)
//
// in the course of development of the MPEG-7 Experimentation Model.
//
// This software module is an implementation of a part of one or more MPEG-7
// Experimentation Model tools as specified by the MPEG-7 Requirements.
//
// ISO/IEC gives users of MPEG-7 free license to this software module or
// modifications thereof for use in hardware or software products claiming
// conformance to MPEG-7.
//
// Those intending to use this software module in hardware or software products
// are advised that its use may infringe existing patents. The original
// developer of this software module and his/her company, the subsequent
// editors and their companies, and ISO/IEC have no liability for use of this
// software module or modifications thereof in an implementation.
//
// Copyright is not released for non MPEG-7 conforming products. The
// organizations named above retain full right to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third parties
// from using the code for non MPEG-7 conforming products.
//
// Copyright (c) 1998-1999.
//
// This notice must be included in all copies or derivative works.
//
// Applicable File Name:  ClientApplications.h
//
#ifndef __CLIENT_APPLICATIONS_H__
#define __CLIENT_APPLICATIONS_H__
#include "XMInterfaces.h"                  /* Naming Convention */
#include "XMObjects.h"                     /* Naming Convention */
#ifdef USEDT
#include "DummyTypeCAppl.h"
#endif
#ifdef USEDTDS
#include "DSDummyTypeCAppl.h"
#endif

#include "TimeSeriesCAppl.h"

#include "ColorLayoutCAppl.h"
#include "ColorStructureCAppl.h"
#include "DominantColorCAppl.h"
#include "GoFGoPColorCAppl.h"
#include "ScalableColorCAppl.h"

#include "EdgeHistCAppl.h"
#include "HomoTextureCAppl.h"
#include "TextureBrowsingCAppl.h"

#include "3DShapeSpectrumCAppl.h"
#include "ContourShapeCAppl.h"
#include "MultiViewCAppl.h"
#include "RegionLocatorCAppl.h"
#include "RegionShapeCAppl.h"
#include "SpatioTemporalLocatorCAppl.h"

#include "CameraMotionCAppl.h"
#include "MotionActivityCAppl.h"
#include "MotionTrajectoryCAppl.h"
#include "ParametricObjectMotionCAppl.h"

#include "FaceRecognitionCAppl.h"

#include "MultiImageCAppl.h"

#include "AudioSignatureCAppl.h"
#include "AudioSpectralFlatnessCAppl.h"
#include "MelodySequenceCAppl.h"
#include "SpokenContentCAppl.h"

#include "AffectiveSegmentFilterCAppl.h"
#include "DependStructureCAppl.h"
#include "ExtendedTextualTypeCAppl.h"
#include "GraphicalCSCAppl.h"
#include "ImportanceHintCAppl.h"
#include "InkSegmentCAppl.h"
#include "MatchingHintCAppl.h"
#include "MediaMetaCAppl.h"
#include "MediaReviewCAppl.h"
#include "MosaicCAppl.h"
#include "OrderingKeyCAppl.h"
#include "PackageCAppl.h"
#include "PhoneticTranslationHintsCAppl.h"
#include "PointOfViewCAppl.h"
#include "SegmentCAppl.h"
#include "SegmentRelGraphCAppl.h"
#include "SemanticCAppl.h"
#include "SpatialResolutionHintCAppl.h"
#include "StateMemberCAppl.h"
#include "StructuredCollectionCAppl.h"
#include "SummarizationCAppl.h"
#include "SummaryPreferencesCAppl.h"
#include "TimeCAppl.h"
#include "UserPreferenceCAppl.h"
//#include "VariationCAppl.h"

#endif //__CLIENT_APPLICATIONS_H__
