///////////////////////////////////////////////////////////////////////////////
//
// This software module was originally developed by
//
// Intel Corporation
// (contributing organizations names)
//
// in the course of development of the MPEG-7 Experimentation Model.
//
// This software module is an implementation of a part of one or more MPEG-7
// Experimentation Model tools as specified by the MPEG-7 Requirements.
//
// ISO/IEC gives users of MPEG-7 free license to this software module or
// modifications thereof for use in hardware or software products claiming
// conformance to MPEG-7.
//
// Those intending to use this software module in hardware or software products
// are advised that its use may infringe existing patents. The original
// developer of this software module and his/her company, the subsequent
// editors and their companies, and ISO/IEC have no liability for use of this
// software module or modifications thereof in an implementation.
//
// Copyright is not released for non MPEG-7 conforming products. The
// organizations named above retain full right to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third parties
// from using the code for non MPEG-7 conforming products.
//
// Copyright (c) 1998-1999.
//
// This notice must be included in all copies or derivative works.
//
// Applicable File Name:  ServerApplications.h
//
#ifndef __SERVER_APPLICATIONS_H__
#define __SERVER_APPLICATIONS_H__
#include "XMInterfaces.h"                               /* Naming Convention */
#include "XMObjects.h"                                  /* Naming Convention */
#ifdef USEDT
#include "DummyTypeSAppl.h"
#endif
#ifdef USEDTDS
#include "DSDummyTypeSAppl.h"
#endif

#include "TimeSeriesSAppl.h"

#include "ColorLayoutSAppl.h"
#include "ColorStructureSAppl.h"
#include "DominantColorSAppl.h"
#include "GoFGoPColorSAppl.h"
#include "ScalableColorSAppl.h"

#include "EdgeHistSAppl.h"
#include "HomoTextureSAppl.h"
#include "TextureBrowsingSAppl.h"

#include "3DShapeSpectrumSAppl.h"
#include "ContourShapeSAppl.h"
#include "MultiViewSAppl.h"
#include "RegionLocatorSAppl.h"
#include "RegionShapeSAppl.h"
#include "SpatioTemporalLocatorSAppl.h"

#include "CameraMotionSAppl.h"
#include "MotionActivitySAppl.h"
#include "MotionTrajectorySAppl.h"
#include "ParametricObjectMotionSAppl.h"

#include "FaceRecognitionSAppl.h"

#include "MultiImageSAppl.h"

#include "SpokenContentSAppl.h"

#include "HierarchicalKeyFrameSAppl.h"
#include "InkSegmentSAppl.h"
#include "MatchingHintSAppl.h"
#include "ModelSAppl.h"
#include "MosaicSAppl.h"
#include "MediaQualitySAppl.h"
#include "SegmentRelGraphSAppl.h"
//#include "SegmentSAppl.h"
//#include "SemanticSAppl.h"
#include "SeqSummaryFastMovingStoryBoardSAppl.h"
#include "SeqSummaryKeywordsSAppl.h"
#include "SequentialSummarySAppl.h"
#include "SoundPropertySAppl.h"
#include "SpaceFrequencyViewSAppl.h"
/* #include "SpatioTemporalDSSAppl.h" */
#include "StateTransitionModelSAppl.h"
#include "StructuredCollectionSAppl.h"
#include "SummarizationSAppl.h"
#include "TranscodingSAppl.h"
#include "TimeSAppl.h"
#include "VariationSAppl.h"
#include "VideoEditingSAppl.h"
#include "VideoTextSAppl.h"

#endif //__SERVER_APPLICATIONS_H__
