///////////////////////////////////////////////////////////////////////////////
//
// This software module was originally developed by
//
// in the course of development of the MPEG-7 Experimentation Model.
//
// This software module is an implementation of a part of one or more MPEG-7
// Experimentation Model tools as specified by the MPEG-7 Requirements.
//
// ISO/IEC gives users of MPEG-7 free license to this software module or
// modifications thereof for use in hardware or software products claiming
// conformance to MPEG-7.
//
// Those intending to use this software module in hardware or software products
// are advised that its use may infringe existing patents. The original
// developer of this software module and his/her company, the subsequent
// editors and their companies, and ISO/IEC have no liability for use of this
// software module or modifications thereof in an implementation.
//
// Copyright is not released for non MPEG-7 conforming products. The
// organizations named above retain full right to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third parties
// from using the code for non MPEG-7 conforming products.
//
// Copyright (c) 1998-1999.
//
// This notice must be included in all copies or derivative works.
//
// Applicable File Name:  XML4Cutil.cpp
//



#ifdef USEXML
#include "XML4Cutils.h"
#include <string>

// Microsoft Visual C++ requires this to use
// Standard Template Library Files

#ifdef WIN32
using std::string;  
#endif

DOMString string_to_DOMString(const string& inStr) {
    // Use a buffer where possible and allocate memory only
    // if string is very large.
    
    char buffer[2000];
    char *cStr = buffer;
    
    if(inStr.size() + 1 > sizeof(buffer))
    {
	cStr = new char[inStr.size() + 1];
    }
    inStr.copy(cStr, inStr.size());
    cStr[inStr.size()] = '\0';
    DOMString domString = DOMString(cStr);
    if (cStr != buffer) delete [] cStr;
    return domString;
};
#endif /* USEXML*/
