///////////////////////////////////////////////////////////////////////////////
//
// This software module was originally developed by
//
// Intel Corporation
// (contributing organizations names)
//
// in the course of development of the MPEG-7 Experimentation Model.
//
// This software module is an implementation of a part of one or more MPEG-7
// Experimentation Model tools as specified by the MPEG-7 Requirements.
//
// ISO/IEC gives users of MPEG-7 free license to this software module or
// modifications thereof for use in hardware or software products claiming
// conformance to MPEG-7.
//
// Those intending to use this software module in hardware or software products
// are advised that its use may infringe existing patents. The original
// developer of this software module and his/her company, the subsequent
// editors and their companies, and ISO/IEC have no liability for use of this
// software module or modifications thereof in an implementation.
//
// Copyright is not released for non MPEG-7 conforming products. The
// organizations named above retain full right to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third parties
// from using the code for non MPEG-7 conforming products.
//
// Copyright (c) 1998-1999.
//
// This notice must be included in all copies or derivative works.
//
// Applicable File Name:  DescriptionSchemes.cpp
//
#include "DescriptionSchemes.h"

using namespace XM;

const UUID P564HistogramDS::myID = UUID("83f1c5e0-db5c-11d2-affe-0080c7e1e76d");
const char *P564HistogramDS::myName = "P564 HistogramDS";

const UUID P564HistogramDS::valID = UUID("96922500-db5c-11d2-affe-0080c7e1e76d");
const char *P564HistogramDS::valName = "P564 Histogram Value DS";

//=============================================================================
P564HistogramDS::P564HistogramDS():
m_isProprietary(false)
{
}

//----------------------------------------------------------------------------
P564HistogramDS::~P564HistogramDS()
{
}

//----------------------------------------------------------------------------
const UUID& P564HistogramDS::GetObjectID(void)
{ return myID; }

//----------------------------------------------------------------------------
const char *P564HistogramDS::GetName(void)
{ return myName; }

//----------------------------------------------------------------------------
const UUID& P564HistogramDS::GetValueID(void)
{ return valID; }

//----------------------------------------------------------------------------
const char* P564HistogramDS::GetValueName(void)
{ return valName; }

//----------------------------------------------------------------------------
bool P564HistogramDS::IsProprietary(void)
{ return m_isProprietary; }

