///////////////////////////////////////////////////////////////////////////////
//
// This software module was originally developed by
//
// Intel Corporation
// TU-Munich, S.Herrmann
// (contributing organizations names)
//
// in the course of development of the MPEG-7 Experimentation Model.
//
// This software module is an implementation of a part of one or more MPEG-7
// Experimentation Model tools as specified by the MPEG-7 Requirements.
//
// ISO/IEC gives users of MPEG-7 free license to this software module or
// modifications thereof for use in hardware or software products claiming
// conformance to MPEG-7.
//
// Those intending to use this software module in hardware or software products
// are advised that its use may infringe existing patents. The original
// developer of this software module and his/her company, the subsequent
// editors and their companies, and ISO/IEC have no liability for use of this
// software module or modifications thereof in an implementation.
//
// Copyright is not released for non MPEG-7 conforming products. The
// organizations named above retain full right to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third parties
// from using the code for non MPEG-7 conforming products.
//
// Copyright (c) 1998-1999.
//
// This notice must be included in all copies or derivative works.
//
// Applicable File Name:  ExtractionUtilities.h
//
#ifndef __EXTRACTIONUTILITIES_H__
#define __EXTRACTIONUTILITIES_H__
#include "XMInterfaces.h"                                   /* Naming Convention */
#include "XMObjects.h"                                      /* Naming Convention */

#include <inter.h>
#include <intra.h>
#include <fifo.h>
#include <vopio.h>
#ifdef EVAL
  #include <eval_functions.h>
  #include "eval_funcdefs.h"
#endif

/*implemented extraction untilities*/
#include "Descriptors.h"
#ifdef USEDT
#include "DummyTypeExtraction.h"
#endif
#ifdef USEDTDS
#include "DSDummyTypeExtraction.h"
#endif

#include "ColorSpaceExtraction.h"
#include "ColorQuantExtraction.h"
#include "TemporalInterpolationExtraction.h"

#include "ColorLayoutExtraction.h"
#include "ColorStructureExtraction.h"
#include "DominantColorExtraction.h"
#include "GoFGoPColorExtraction.h"
#include "ScalableColorExtraction.h"

#include "EdgeHistExtraction.h"
#include "HomoTextureExtraction.h"
#include "TextureBrowsingExtraction.h"

#include "3DShapeSpectrumExtraction.h"
#include "ContourShapeExtraction.h"
#include "MultiViewExtraction.h"
#include "RegionLocatorExtraction.h"
#include "RegionShapeExtraction.h"
#include "SpatioTemporalLocatorExtraction.h"

#include "CameraMotionExtraction.h"
#include "MotionActivityExtraction.h"
#include "MotionTrajectoryExtraction.h"
#include "ParametricObjectMotionExtraction.h"
#include "ParametricObjectMotionExtraction2.h"

#include "FaceRecognitionExtraction.h"

#include "MultiImageExtraction.h"

#include "TimeSeriesExtraction.h"

// Audio implemented MDS stuff
#include "ProbabilityVectorExtraction.h"
#include "ProbabilityMatrixExtraction.h"

// Spoken content stuff
#include "SpokenContentIndexEntryExtraction.h"
#include "SpokenContentLexiconExtraction.h"
#include "SpokenContentWordLexiconExtraction.h"
#include "SpokenContentLinkExtraction.h"
#include "SpokenContentWordLinkExtraction.h"
#include "SpokenContentPhoneLinkExtraction.h"
#include "SpokenContentConfusionInfoExtraction.h"
#include "SpokenContentPhoneLexiconExtraction.h"
#include "SpokenContentPhoneIndexEntryExtraction.h"
#include "SpokenContentWordIndexEntryExtraction.h"
#include "SpokenContentSpeakerExtraction.h"
#include "SpokenContentHeaderExtraction.h"
#include "SpokenContentNodeExtraction.h"
#include "SpokenContentBlockExtraction.h"
#include "SpokenContentLatticeExtraction.h"
#include "SpokenContentExtraction.h"

#include "HierarchicalKeyFrameExtraction.h"
#include "InkSegmentExtraction.h"
#include "MatchingHintExtraction.h"
#include "MediaQualityExtraction.h"
#include "ModelExtraction.h"
#include "MosaicExtraction.h"
//#include "SegmentExtraction.h"
#include "SegmentRelGraphExtraction.h"
#include "SoundPropertyExtraction.h"
#include "SpaceFrequencyViewExtraction.h"
#include "SeqSummaryFastMovingStoryBoardExtraction.h"
#include "SeqSummaryKeywordsExtraction.h"
#include "SequentialSummaryExtraction.h"
#include "StateTransitionModelExtraction.h"
#include "StructuredCollectionExtraction.h"
#include "SummarizationExtraction.h"
#include "TranscodingHintsExtraction.h"
#include "TimeExtraction.h"
#include "VariationExtraction.h"
#include "VideoEditingExtraction.h"
#include "VideoTextExtraction.h"

#endif //__EXTRACTIONUTILITIES_H__
